Enable a feature flag in an environment

POST https://api.ap1.datadoghq.com/api/v2/feature-flags/{feature_flag_id}/environments/{environment_id}/enablehttps://api.ap2.datadoghq.com/api/v2/feature-flags/{feature_flag_id}/environments/{environment_id}/enablehttps://api.datadoghq.eu/api/v2/feature-flags/{feature_flag_id}/environments/{environment_id}/enablehttps://api.ddog-gov.com/api/v2/feature-flags/{feature_flag_id}/environments/{environment_id}/enablehttps://api.us2.ddog-gov.com/api/v2/feature-flags/{feature_flag_id}/environments/{environment_id}/enablehttps://api.datadoghq.com/api/v2/feature-flags/{feature_flag_id}/environments/{environment_id}/enablehttps://api.us3.datadoghq.com/api/v2/feature-flags/{feature_flag_id}/environments/{environment_id}/enablehttps://api.us5.datadoghq.com/api/v2/feature-flags/{feature_flag_id}/environments/{environment_id}/enable

Overview

Enable a feature flag in a specific environment. This endpoint requires all of the following permissions:

  • feature_flag_config_write
  • feature_flag_environment_config_read

  • Arguments

    Path Parameters

    Name

    Type

    Description

    feature_flag_id [required]

    string

    The ID of the feature flag.

    environment_id [required]

    string

    The ID of the environment.

    Response

    OK

    Accepted - Approval required for this change

    Forbidden

    API error response.

    Expand All

    Field

    Type

    Description

    errors [required]

    [string]

    A list of errors.

    {
      "errors": [
        "Bad Request"
      ]
    }

    Not Found

    API error response.

    Expand All

    Field

    Type

    Description

    errors [required]

    [string]

    A list of errors.

    {
      "errors": [
        "Bad Request"
      ]
    }

    Too many requests

    API error response.

    Expand All

    Field

    Type

    Description

    errors [required]

    [string]

    A list of errors.

    {
      "errors": [
        "Bad Request"
      ]
    }

    Code Example

                      # Path parameters
    export feature_flag_id="550e8400-e29b-41d4-a716-446655440000"
    export environment_id="550e8400-e29b-41d4-a716-446655440001"
    # Curl command
    curl -X POST "https://api.ap1.datadoghq.com"https://api.ap2.datadoghq.com"https://api.datadoghq.eu"https://api.ddog-gov.com"https://api.us2.ddog-gov.com"https://api.datadoghq.com"https://api.us3.datadoghq.com"https://api.us5.datadoghq.com/api/v2/feature-flags/${feature_flag_id}/environments/${environment_id}/enable" \ -H "Accept: application/json" \ -H "DD-API-KEY: ${DD_API_KEY}" \ -H "DD-APPLICATION-KEY: ${DD_APP_KEY}"
    """
    Enable a feature flag in an environment returns "OK" response
    """
    
    from os import environ
    from datadog_api_client import ApiClient, Configuration
    from datadog_api_client.v2.api.feature_flags_api import FeatureFlagsApi
    
    # there is a valid "feature_flag" in the system
    FEATURE_FLAG_DATA_ID = environ["FEATURE_FLAG_DATA_ID"]
    
    # there is a valid "environment" in the system
    ENVIRONMENT_DATA_ID = environ["ENVIRONMENT_DATA_ID"]
    
    configuration = Configuration()
    with ApiClient(configuration) as api_client:
        api_instance = FeatureFlagsApi(api_client)
        api_instance.enable_feature_flag_environment(
            feature_flag_id=FEATURE_FLAG_DATA_ID,
            environment_id=ENVIRONMENT_DATA_ID,
        )
    

    Instructions

    First install the library and its dependencies and then save the example to example.py and run following commands:

        
    DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" python3 "example.py"
    # Enable a feature flag in an environment returns "OK" response
    
    require "datadog_api_client"
    api_instance = DatadogAPIClient::V2::FeatureFlagsAPI.new
    
    # there is a valid "feature_flag" in the system
    FEATURE_FLAG_DATA_ID = ENV["FEATURE_FLAG_DATA_ID"]
    
    # there is a valid "environment" in the system
    ENVIRONMENT_DATA_ID = ENV["ENVIRONMENT_DATA_ID"]
    p api_instance.enable_feature_flag_environment(FEATURE_FLAG_DATA_ID, ENVIRONMENT_DATA_ID)
    

    Instructions

    First install the library and its dependencies and then save the example to example.rb and run following commands:

        
    DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" rb "example.rb"
    // Enable a feature flag in an environment returns "OK" response
    
    package main
    
    import (
    	"context"
    	"fmt"
    	"os"
    
    	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
    	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
    	"github.com/google/uuid"
    )
    
    func main() {
    	// there is a valid "feature_flag" in the system
    	FeatureFlagDataID := uuid.MustParse(os.Getenv("FEATURE_FLAG_DATA_ID"))
    
    	// there is a valid "environment" in the system
    	EnvironmentDataID := uuid.MustParse(os.Getenv("ENVIRONMENT_DATA_ID"))
    
    	ctx := datadog.NewDefaultContext(context.Background())
    	configuration := datadog.NewConfiguration()
    	apiClient := datadog.NewAPIClient(configuration)
    	api := datadogV2.NewFeatureFlagsApi(apiClient)
    	r, err := api.EnableFeatureFlagEnvironment(ctx, FeatureFlagDataID, EnvironmentDataID)
    
    	if err != nil {
    		fmt.Fprintf(os.Stderr, "Error when calling `FeatureFlagsApi.EnableFeatureFlagEnvironment`: %v\n", err)
    		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
    	}
    }
    

    Instructions

    First install the library and its dependencies and then save the example to main.go and run following commands:

        
    DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" go run "main.go"
    // Enable a feature flag in an environment returns "OK" response
    
    import com.datadog.api.client.ApiClient;
    import com.datadog.api.client.ApiException;
    import com.datadog.api.client.v2.api.FeatureFlagsApi;
    import java.util.UUID;
    
    public class Example {
      public static void main(String[] args) {
        ApiClient defaultClient = ApiClient.getDefaultApiClient();
        FeatureFlagsApi apiInstance = new FeatureFlagsApi(defaultClient);
    
        // there is a valid "feature_flag" in the system
        UUID FEATURE_FLAG_DATA_ID = null;
        try {
          FEATURE_FLAG_DATA_ID = UUID.fromString(System.getenv("FEATURE_FLAG_DATA_ID"));
        } catch (IllegalArgumentException e) {
          System.err.println("Error parsing UUID: " + e.getMessage());
        }
    
        // there is a valid "environment" in the system
        UUID ENVIRONMENT_DATA_ID = null;
        try {
          ENVIRONMENT_DATA_ID = UUID.fromString(System.getenv("ENVIRONMENT_DATA_ID"));
        } catch (IllegalArgumentException e) {
          System.err.println("Error parsing UUID: " + e.getMessage());
        }
    
        try {
          apiInstance.enableFeatureFlagEnvironment(FEATURE_FLAG_DATA_ID, ENVIRONMENT_DATA_ID);
        } catch (ApiException e) {
          System.err.println("Exception when calling FeatureFlagsApi#enableFeatureFlagEnvironment");
          System.err.println("Status code: " + e.getCode());
          System.err.println("Reason: " + e.getResponseBody());
          System.err.println("Response headers: " + e.getResponseHeaders());
          e.printStackTrace();
        }
      }
    }
    

    Instructions

    First install the library and its dependencies and then save the example to Example.java and run following commands:

        
    DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" java "Example.java"
    // Enable a feature flag in an environment returns "OK" response
    use datadog_api_client::datadog;
    use datadog_api_client::datadogV2::api_feature_flags::FeatureFlagsAPI;
    
    #[tokio::main]
    async fn main() {
        // there is a valid "feature_flag" in the system
        let feature_flag_data_id =
            uuid::Uuid::parse_str(&std::env::var("FEATURE_FLAG_DATA_ID").unwrap())
                .expect("Invalid UUID");
    
        // there is a valid "environment" in the system
        let environment_data_id = uuid::Uuid::parse_str(&std::env::var("ENVIRONMENT_DATA_ID").unwrap())
            .expect("Invalid UUID");
        let configuration = datadog::Configuration::new();
        let api = FeatureFlagsAPI::with_config(configuration);
        let resp = api
            .enable_feature_flag_environment(feature_flag_data_id.clone(), environment_data_id.clone())
            .await;
        if let Ok(value) = resp {
            println!("{:#?}", value);
        } else {
            println!("{:#?}", resp.unwrap_err());
        }
    }
    

    Instructions

    First install the library and its dependencies and then save the example to src/main.rs and run following commands:

        
    DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" cargo run
    /**
     * Enable a feature flag in an environment returns "OK" response
     */
    
    import { client, v2 } from "@datadog/datadog-api-client";
    
    const configuration = client.createConfiguration();
    const apiInstance = new v2.FeatureFlagsApi(configuration);
    
    // there is a valid "feature_flag" in the system
    const FEATURE_FLAG_DATA_ID = process.env.FEATURE_FLAG_DATA_ID as string;
    
    // there is a valid "environment" in the system
    const ENVIRONMENT_DATA_ID = process.env.ENVIRONMENT_DATA_ID as string;
    
    const params: v2.FeatureFlagsApiEnableFeatureFlagEnvironmentRequest = {
      featureFlagId: FEATURE_FLAG_DATA_ID,
      environmentId: ENVIRONMENT_DATA_ID,
    };
    
    apiInstance
      .enableFeatureFlagEnvironment(params)
      .then((data: any) => {
        console.log(
          "API called successfully. Returned data: " + JSON.stringify(data)
        );
      })
      .catch((error: any) => console.error(error));
    

    Instructions

    First install the library and its dependencies and then save the example to example.ts and run following commands:

        
    DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" tsc "example.ts"